package tcadaption.sandbox;

import tcadaption.BoundsUtil;
import fj.P1;
import fj.data.Either;

public class TransferVolumeIntsDefaultImpl implements TransferVolumeInts {

	static int MIN = 0;
	static int MAX = 10000;
	static int value = MIN ;

	public Integer getVolume() {
		
		return TransferVolumeIntsDefaultImpl.value ;
	}

	private static P1<Either<Exception, Integer>> eSetVolume(final Integer volume) {
		return new P1<Either<Exception, Integer>>() {
			@Override
			public Either<Exception, Integer> _1() {
				try {
					if (BoundsUtil.isOuterBounds(volume, MIN, MAX)) {
						throw new Exception(volume + " outer bounds");
					}
					TransferVolumeIntsDefaultImpl.value = volume;
					return Either.right(TransferVolumeIntsDefaultImpl.value);
				} catch (Exception e) {
					return Either.left(e);
				}
			}

		};
	}
	
	public boolean setVolume(Integer volume) {
		int EDOM = -1;
		P1<Either<Exception, Integer>> lazyE = TransferVolumeIntsDefaultImpl.eSetVolume(volume);
		TransferVolumeIntsDefaultImpl.value = (lazyE._1().isLeft() ? EDOM : lazyE._1().right().value());
		if(lazyE._1().isLeft()) {
			System.err.println("Failed with " + lazyE._1().left().value());
			return false;
		}
		return true;
	}
}
