/**
 * Copyright (C) 2010 [[XYZ]], Helmholtz Centre for Environmental Research GmbH - UFZ <abmland@ufz.de>
 *
 *    Licensed under the Apache License, Version 2.0 (the "License");
 *    you may not use this file except in compliance with the License.
 *    You may obtain a copy of the License at
 *
 *        http://www.apache.org/licenses/LICENSE-2.0
 *
 *    Unless required by applicable law or agreed to in writing, software
 *    distributed under the License is distributed on an "AS IS" BASIS,
 *    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *    See the License for the specific language governing permissions and
 *    limitations under the License.
 */

package abmland.common;

public final class ScheduleProperties
{
  public static final double MAINCTRL_COMPUTE_SCHED_P = 1000.0D;
  public static final double MAINCTRL_GETDATA_SCHED_P = (1.0D / 0.0D);
  public static final double MAINCTRL_INIT_SCHED_P = (1.0D / 0.0D);
  public static final double MODEL_COMPUTE_SCHED_P = 998.0D;
  public static final double MODEL_GETDATA_SCHED_P = 999.0D;
  public static final double MODEL_INIT_SCHED_P = 1.7976931348623157E+308D;
  public static final double AGENT_INIT_WATCH_TRIGGER_P = (1.0D / 0.0D);
  public static final double AGENT_STEP_WATCH_TRIGGER_P = (1.0D / 0.0D);
  public static final boolean NO_TEST_SCHEDULE = false;
  public static final String DECISION_MODE_IS_STATIC_COND = "$watchee.getDecisionMode().name() == \"STATIC\"";
  public static final String DECISION_MODE_IS_CLEVER_COND = "$watchee.getDecisionMode().name() == \"CLEVER\"";
  public static final String DECISION_MODE_IS_RANDOM_COND = "$watchee.getDecisionMode().name() == \"RANDOM\"";
}