package tcadaption.sandbox;
/**
 * This interface describes the volume or amount of transferable units.
 * 
 * Implementations should take care of lower and upper bounds, especially when updating the volume size's value.
 * 
 * @author dkahlenb
 *
 */
public interface TransferVolume<T> {

	T getVolume();

	boolean setVolume(T volume);

	// void setMax(T max);
	//	
	// void setMin(T min);
}
